package geniusweb.boa;

import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class CrashingClassTest {
	private static final String CRASHINGCLASSPATH = "geniusweb.boa.CrashingClass";

	@Test(expected = ExceptionInInitializerError.class)
	public void testForNameCrashes() throws ClassNotFoundException {
		// forName DOES run the static code.
		Class<?> clazz = Class.forName(CRASHINGCLASSPATH);
	}

	@Test
	public void testLoadCrashes() throws ClassNotFoundException {
		// loadClass does NOT run the static code.
		Class<?> clazz = this.getClass().getClassLoader()
				.loadClass(CRASHINGCLASSPATH);
		assertTrue(clazz.isAssignableFrom(CrashingClass.class));
	}

	@Test
	public void testImportCrashes() {
		// refering to crashing class does NOT trigger the static code
		Class<CrashingClass> clazz = CrashingClass.class;
	}
}
